# ------------------------------
# Run estimation
# ------------------------------

indic_starts.with.bond.spreads <- 0 # if 1, the first estimation stages are based on bons spreads, and not CDS spreads (bond spreads are faster to compute)
indic_starts.from.saved.model  <- 1 # if 1, the estimations starts from saved results (using the path given below).

indic_shutdown_S <- 0 # if = 1, then S = 0
indic_shutdown_I <- 1 # if = 1, then I = 0
indic_shutdown_C <- 0 # if = 1, then C = 0
indic_no_z       <- 0 # if = 1, then no common (frailty) factor

# In case one wants to set a maximum Sharpe ratio:
# (if NaN, no bound, otherwise, the value is the bound)
indic_max.avg.annual.SharpeRatio <- 1

# ------------------------------

# Build an initial model:
source('estimation/make.ini.model.R')


if(indic_starts.from.saved.model == 0){
  THETA <- MODEL.2.THETA(Model.ini,kappa,weights.spds)
}else{
  load(file = path.stored.results)
}

if(indic_starts.with.bond.spreads == 1){
  indic.cds <- 0
  nb.loops <- 2
  nb.sub.loops <- 1
  mult.4.NlMd <- 50
  mult.4.nlminb <- 1
  
  source('estimation/run.estim.aux.R')
}

indic.cds <- 1
nb.loops <- 100
nb.sub.loops <- 1
mult.4.NlMd <- 100
mult.4.nlminb <- 1

source('estimation/run.estim.aux.R')
