
# Investigate the effect of contagion by killing the contagion channel

paths <- c(
  "results/param_baseline",
  "results/param_no_S",
  "results/param_no_z",
  "results/param_no_Sz"
)

paths <- paste(paths,".Rdat",sep="")

for(est.model in paths){
  load(est.model)
  # check logl:
  Model <- THETA.2.MODEL(THETA,kappa,weights.spds)
  system.time({
    res.filter <- run.Filter(Model,DATA,
                             indic.cds=indic.cds, # 1 to use CDS formula (RMV otherwise)
                             indic.smoother = 1, # 1 to compute Risk Premiums
                             indic_max.avg.annual.SharpeRatio = indic_max.avg.annual.SharpeRatio
    )
  })
  
  n.e <- Model$n.e
  n.y <- Model$n.y

  W <- rbind(res.filter$W.smoothed[1:n.y,],
             matrix(0,n.e,length(DATA$Date)))

  Model.Q <- make.Model.Q(Model)
  cds.pricing <- pricing.CDS(Model.Q,u=-10000,
                             max(12 * maturities.in.years),W)
  cds.pricing.P <- pricing.CDS(Model,u=-10000,
                               max(12 * maturities.in.years),W)
  
  dim(cds.pricing$prices)

  Model.no.contagion <- Model
  Model.no.contagion$beta.ee[] <- 0.0000000000000000000000000000001
  
  Model.no.contagion.Q <- make.Model.Q(Model.no.contagion)
  cds.pricing.no.contagion <- pricing.CDS(Model.no.contagion.Q,u=-10000,
                                          max(12 * maturities.in.years),W)
  
  
  ratios <- (cds.pricing$prices - cds.pricing.no.contagion$prices)/cds.pricing$prices
  
  print(paste("Deacrease in spread size: ",toString(mean(ratios,na.rm = TRUE)),sep=""))
  
}


